##
## ocean.nas
##
##  Nasal code for managing ocean related random objects.

UPDATE_INTERVAL = 10;

##
# Singleton class that manages icebergs. It's started with icebergs.init()
# and then works autonomously.
#
var icebergs = {
    init : func {
        me.enabled =
            props.globals.getNode("/environment/ocean/icebergs/enabled", 1);
        me.present =
            props.globals.getNode("/environment/ocean/icebergs/present", 1);
        me.loopid = 0;
        _setlistener("/environment/ocean/icebergs/enabled",
                     func { icebergs.update(); });
	me.reset();
	print("Ocean.icebergs ... initialized");
    },
    reset: func {
        me.loopid += 1;
        me._loop_(me.loopid);
    },
    update : func {
        var pos = geo.aircraft_position();
        me.present.setValue((pos.lat() > 58.0) and me.enabled.getValue());
#        print("Ocean.icebergs ... refreshed pos " ~
#              pos.lon() ~ "," ~ pos.lat());
    },
    _loop_ : func(id) {
        id == me.loopid or return;
        me.update();
        settimer(func { me._loop_(id); }, UPDATE_INTERVAL);
    },
};

_setlistener("/sim/signals/fdm-initialized", func {
    icebergs.init();
});
